
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TMemo struct {
    IWinControl
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// 创建一个新的对象。
// 
// Create a new object.
func NewMemo(owner IComponent) *TMemo {
    m := new(TMemo)
    m.instance = Memo_Create(CheckPtr(owner))
    m.ptr = unsafe.Pointer(m.instance)
    return m
}

// 动态转换一个已存在的对象实例。
// 
// Dynamically convert an existing object instance.
func AsMemo(obj interface{}) *TMemo {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TMemo{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// 新建一个对象来自已经存在的对象实例指针。
// 
// Create a new object from an existing object instance pointer.
// Deprecated: use AsMemo.
func MemoFromInst(inst uintptr) *TMemo {
    return AsMemo(inst)
}

// 新建一个对象来自已经存在的对象实例。
// 
// Create a new object from an existing object instance.
// Deprecated: use AsMemo.
func MemoFromObj(obj IObject) *TMemo {
    return AsMemo(obj)
}

// 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// 
// Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsMemo.
func MemoFromUnsafePointer(ptr unsafe.Pointer) *TMemo {
    return AsMemo(ptr)
}

// -------------------------- Deprecated end --------------------------
// 释放对象。
// 
// Free object.
func (m *TMemo) Free() {
    if m.instance != 0 {
        Memo_Free(m.instance)
        m.instance, m.ptr = 0, nullptr
    }
}

// 返回对象实例指针。
// 
// Return object instance pointer.
func (m *TMemo) Instance() uintptr {
    return m.instance
}

// 获取一个不安全的地址。
// 
// Get an unsafe address.
func (m *TMemo) UnsafeAddr() unsafe.Pointer {
    return m.ptr
}

// 检测地址是否为空。
// 
// Check if the address is empty.
func (m *TMemo) IsValid() bool {
    return m.instance != 0
}

// 检测当前对象是否继承自目标对象。
// 
// Checks whether the current object is inherited from the target object.
func (m *TMemo) Is() TIs {
    return TIs(m.instance)
}

// 动态转换当前对象为目标对象。
// 
// Dynamically convert the current object to the target object.
//func (m *TMemo) As() TAs {
//    return TAs(m.instance)
//}

// 获取类信息指针。
// 
// Get class information pointer.
func TMemoClass() TClass {
    return Memo_StaticClassType()
}

func (m *TMemo) Append(Value string) {
    Memo_Append(m.instance, Value)
}

// 清除。
func (m *TMemo) Clear() {
    Memo_Clear(m.instance)
}

// 清除选择。
func (m *TMemo) ClearSelection() {
    Memo_ClearSelection(m.instance)
}

// 复制到粘贴板。
func (m *TMemo) CopyToClipboard() {
    Memo_CopyToClipboard(m.instance)
}

// 剪切到粘贴板。
func (m *TMemo) CutToClipboard() {
    Memo_CutToClipboard(m.instance)
}

// 从剪切板粘贴。
func (m *TMemo) PasteFromClipboard() {
    Memo_PasteFromClipboard(m.instance)
}

// 撤销上一次操作。
func (m *TMemo) Undo() {
    Memo_Undo(m.instance)
}

// 全选。
func (m *TMemo) SelectAll() {
    Memo_SelectAll(m.instance)
}

// 是否可以获得焦点。
func (m *TMemo) CanFocus() bool {
    return Memo_CanFocus(m.instance)
}

// 返回是否包含指定控件。
//
// it's contain a specified control.
func (m *TMemo) ContainsControl(Control IControl) bool {
    return Memo_ContainsControl(m.instance, CheckPtr(Control))
}

// 返回指定坐标及相关属性位置控件。
//
// Returns the specified coordinate and the relevant attribute position control..
func (m *TMemo) ControlAtPos(Pos TPoint, AllowDisabled bool, AllowWinControls bool, AllLevels bool) *TControl {
    return AsControl(Memo_ControlAtPos(m.instance, Pos , AllowDisabled , AllowWinControls , AllLevels))
}

// 禁用控件的对齐。
//
// Disable control alignment.
func (m *TMemo) DisableAlign() {
    Memo_DisableAlign(m.instance)
}

// 启用控件对齐。
//
// Enabled control alignment.
func (m *TMemo) EnableAlign() {
    Memo_EnableAlign(m.instance)
}

// 查找子控件。
//
// Find sub controls.
func (m *TMemo) FindChildControl(ControlName string) *TControl {
    return AsControl(Memo_FindChildControl(m.instance, ControlName))
}

func (m *TMemo) FlipChildren(AllLevels bool) {
    Memo_FlipChildren(m.instance, AllLevels)
}

// 返回是否获取焦点。
//
// Return to get focus.
func (m *TMemo) Focused() bool {
    return Memo_Focused(m.instance)
}

// 句柄是否已经分配。
//
// Is the handle already allocated.
func (m *TMemo) HandleAllocated() bool {
    return Memo_HandleAllocated(m.instance)
}

// 插入一个控件。
//
// Insert a control.
func (m *TMemo) InsertControl(AControl IControl) {
    Memo_InsertControl(m.instance, CheckPtr(AControl))
}

// 要求重绘。
//
// Redraw.
func (m *TMemo) Invalidate() {
    Memo_Invalidate(m.instance)
}

// 绘画至指定DC。
//
// Painting to the specified DC.
func (m *TMemo) PaintTo(DC HDC, X int32, Y int32) {
    Memo_PaintTo(m.instance, DC , X , Y)
}

// 移除一个控件。
//
// Remove a control.
func (m *TMemo) RemoveControl(AControl IControl) {
    Memo_RemoveControl(m.instance, CheckPtr(AControl))
}

// 重新对齐。
//
// Realign.
func (m *TMemo) Realign() {
    Memo_Realign(m.instance)
}

// 重绘。
//
// Repaint.
func (m *TMemo) Repaint() {
    Memo_Repaint(m.instance)
}

// 按比例缩放。
//
// Scale by.
func (m *TMemo) ScaleBy(M int32, D int32) {
    Memo_ScaleBy(m.instance, M , D)
}

// 滚动至指定位置。
//
// Scroll by.
func (m *TMemo) ScrollBy(DeltaX int32, DeltaY int32) {
    Memo_ScrollBy(m.instance, DeltaX , DeltaY)
}

// 设置组件边界。
//
// Set component boundaries.
func (m *TMemo) SetBounds(ALeft int32, ATop int32, AWidth int32, AHeight int32) {
    Memo_SetBounds(m.instance, ALeft , ATop , AWidth , AHeight)
}

// 设置控件焦点。
//
// Set control focus.
func (m *TMemo) SetFocus() {
    Memo_SetFocus(m.instance)
}

// 控件更新。
//
// Update.
func (m *TMemo) Update() {
    Memo_Update(m.instance)
}

// 将控件置于最前。
//
// Bring the control to the front.
func (m *TMemo) BringToFront() {
    Memo_BringToFront(m.instance)
}

// 将客户端坐标转为绝对的屏幕坐标。
//
// Convert client coordinates to absolute screen coordinates.
func (m *TMemo) ClientToScreen(Point TPoint) TPoint {
    return Memo_ClientToScreen(m.instance, Point)
}

// 将客户端坐标转为父容器坐标。
//
// Convert client coordinates to parent container coordinates.
func (m *TMemo) ClientToParent(Point TPoint, AParent IWinControl) TPoint {
    return Memo_ClientToParent(m.instance, Point , CheckPtr(AParent))
}

// 是否在拖拽中。
//
// Is it in the middle of dragging.
func (m *TMemo) Dragging() bool {
    return Memo_Dragging(m.instance)
}

// 是否有父容器。
//
// Is there a parent container.
func (m *TMemo) HasParent() bool {
    return Memo_HasParent(m.instance)
}

// 隐藏控件。
//
// Hidden control.
func (m *TMemo) Hide() {
    Memo_Hide(m.instance)
}

// 发送一个消息。
//
// Send a message.
func (m *TMemo) Perform(Msg uint32, WParam uintptr, LParam int) int {
    return Memo_Perform(m.instance, Msg , WParam , LParam)
}

// 刷新控件。
//
// Refresh control.
func (m *TMemo) Refresh() {
    Memo_Refresh(m.instance)
}

// 将屏幕坐标转为客户端坐标。
//
// Convert screen coordinates to client coordinates.
func (m *TMemo) ScreenToClient(Point TPoint) TPoint {
    return Memo_ScreenToClient(m.instance, Point)
}

// 将父容器坐标转为客户端坐标。
//
// Convert parent container coordinates to client coordinates.
func (m *TMemo) ParentToClient(Point TPoint, AParent IWinControl) TPoint {
    return Memo_ParentToClient(m.instance, Point , CheckPtr(AParent))
}

// 控件至于最后面。
//
// The control is placed at the end.
func (m *TMemo) SendToBack() {
    Memo_SendToBack(m.instance)
}

// 显示控件。
//
// Show control.
func (m *TMemo) Show() {
    Memo_Show(m.instance)
}

// 获取控件的字符，如果有。
//
// Get the characters of the control, if any.
func (m *TMemo) GetTextBuf(Buffer *string, BufSize int32) int32 {
    return Memo_GetTextBuf(m.instance, Buffer , BufSize)
}

// 获取控件的字符长，如果有。
//
// Get the character length of the control, if any.
func (m *TMemo) GetTextLen() int32 {
    return Memo_GetTextLen(m.instance)
}

// 设置控件字符，如果有。
//
// Set control characters, if any.
func (m *TMemo) SetTextBuf(Buffer string) {
    Memo_SetTextBuf(m.instance, Buffer)
}

// 查找指定名称的组件。
//
// Find the component with the specified name.
func (m *TMemo) FindComponent(AName string) *TComponent {
    return AsComponent(Memo_FindComponent(m.instance, AName))
}

// 获取类名路径。
//
// Get the class name path.
func (m *TMemo) GetNamePath() string {
    return Memo_GetNamePath(m.instance)
}

// 复制一个对象，如果对象实现了此方法的话。
//
// Copy an object, if the object implements this method.
func (m *TMemo) Assign(Source IObject) {
    Memo_Assign(m.instance, CheckPtr(Source))
}

// 获取类的类型信息。
//
// Get class type information.
func (m *TMemo) ClassType() TClass {
    return Memo_ClassType(m.instance)
}

// 获取当前对象类名称。
//
// Get the current object class name.
func (m *TMemo) ClassName() string {
    return Memo_ClassName(m.instance)
}

// 获取当前对象实例大小。
//
// Get the current object instance size.
func (m *TMemo) InstanceSize() int32 {
    return Memo_InstanceSize(m.instance)
}

// 判断当前类是否继承自指定类。
//
// Determine whether the current class inherits from the specified class.
func (m *TMemo) InheritsFrom(AClass TClass) bool {
    return Memo_InheritsFrom(m.instance, AClass)
}

// 与一个对象进行比较。
//
// Compare with an object.
func (m *TMemo) Equals(Obj IObject) bool {
    return Memo_Equals(m.instance, CheckPtr(Obj))
}

// 获取类的哈希值。
//
// Get the hash value of the class.
func (m *TMemo) GetHashCode() int32 {
    return Memo_GetHashCode(m.instance)
}

// 文本类信息。
//
// Text information.
func (m *TMemo) ToString() string {
    return Memo_ToString(m.instance)
}

func (m *TMemo) AnchorToNeighbour(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    Memo_AnchorToNeighbour(m.instance, ASide , ASpace , CheckPtr(ASibling))
}

func (m *TMemo) AnchorParallel(ASide TAnchorKind, ASpace int32, ASibling IControl) {
    Memo_AnchorParallel(m.instance, ASide , ASpace , CheckPtr(ASibling))
}

// 置于指定控件的横向中心。
func (m *TMemo) AnchorHorizontalCenterTo(ASibling IControl) {
    Memo_AnchorHorizontalCenterTo(m.instance, CheckPtr(ASibling))
}

// 置于指定控件的纵向中心。
func (m *TMemo) AnchorVerticalCenterTo(ASibling IControl) {
    Memo_AnchorVerticalCenterTo(m.instance, CheckPtr(ASibling))
}

func (m *TMemo) AnchorSame(ASide TAnchorKind, ASibling IControl) {
    Memo_AnchorSame(m.instance, ASide , CheckPtr(ASibling))
}

func (m *TMemo) AnchorAsAlign(ATheAlign TAlign, ASpace int32) {
    Memo_AnchorAsAlign(m.instance, ATheAlign , ASpace)
}

func (m *TMemo) AnchorClient(ASpace int32) {
    Memo_AnchorClient(m.instance, ASpace)
}

func (m *TMemo) ScaleDesignToForm(ASize int32) int32 {
    return Memo_ScaleDesignToForm(m.instance, ASize)
}

func (m *TMemo) ScaleFormToDesign(ASize int32) int32 {
    return Memo_ScaleFormToDesign(m.instance, ASize)
}

func (m *TMemo) Scale96ToForm(ASize int32) int32 {
    return Memo_Scale96ToForm(m.instance, ASize)
}

func (m *TMemo) ScaleFormTo96(ASize int32) int32 {
    return Memo_ScaleFormTo96(m.instance, ASize)
}

func (m *TMemo) Scale96ToFont(ASize int32) int32 {
    return Memo_Scale96ToFont(m.instance, ASize)
}

func (m *TMemo) ScaleFontTo96(ASize int32) int32 {
    return Memo_ScaleFontTo96(m.instance, ASize)
}

func (m *TMemo) ScaleScreenToFont(ASize int32) int32 {
    return Memo_ScaleScreenToFont(m.instance, ASize)
}

func (m *TMemo) ScaleFontToScreen(ASize int32) int32 {
    return Memo_ScaleFontToScreen(m.instance, ASize)
}

func (m *TMemo) Scale96ToScreen(ASize int32) int32 {
    return Memo_Scale96ToScreen(m.instance, ASize)
}

func (m *TMemo) ScaleScreenTo96(ASize int32) int32 {
    return Memo_ScaleScreenTo96(m.instance, ASize)
}

func (m *TMemo) AutoAdjustLayout(AMode TLayoutAdjustmentPolicy, AFromPPI int32, AToPPI int32, AOldFormWidth int32, ANewFormWidth int32) {
    Memo_AutoAdjustLayout(m.instance, AMode , AFromPPI , AToPPI , AOldFormWidth , ANewFormWidth)
}

func (m *TMemo) FixDesignFontsPPI(ADesignTimePPI int32) {
    Memo_FixDesignFontsPPI(m.instance, ADesignTimePPI)
}

func (m *TMemo) ScaleFontsPPI(AToPPI int32, AProportion float64) {
    Memo_ScaleFontsPPI(m.instance, AToPPI , AProportion)
}

// 获取控件自动调整。
//
// Get Control automatically adjusts.
func (m *TMemo) Align() TAlign {
    return Memo_GetAlign(m.instance)
}

// 设置控件自动调整。
//
// Set Control automatically adjusts.
func (m *TMemo) SetAlign(value TAlign) {
    Memo_SetAlign(m.instance, value)
}

// 获取文字对齐。
//
// Get Text alignment.
func (m *TMemo) Alignment() TAlignment {
    return Memo_GetAlignment(m.instance)
}

// 设置文字对齐。
//
// Set Text alignment.
func (m *TMemo) SetAlignment(value TAlignment) {
    Memo_SetAlignment(m.instance, value)
}

// 获取四个角位置的锚点。
func (m *TMemo) Anchors() TAnchors {
    return Memo_GetAnchors(m.instance)
}

// 设置四个角位置的锚点。
func (m *TMemo) SetAnchors(value TAnchors) {
    Memo_SetAnchors(m.instance, value)
}

func (m *TMemo) BiDiMode() TBiDiMode {
    return Memo_GetBiDiMode(m.instance)
}

func (m *TMemo) SetBiDiMode(value TBiDiMode) {
    Memo_SetBiDiMode(m.instance, value)
}

// 获取窗口边框样式。比如：无边框，单一边框等。
func (m *TMemo) BorderStyle() TBorderStyle {
    return Memo_GetBorderStyle(m.instance)
}

// 设置窗口边框样式。比如：无边框，单一边框等。
func (m *TMemo) SetBorderStyle(value TBorderStyle) {
    Memo_SetBorderStyle(m.instance, value)
}

func (m *TMemo) CharCase() TEditCharCase {
    return Memo_GetCharCase(m.instance)
}

func (m *TMemo) SetCharCase(value TEditCharCase) {
    Memo_SetCharCase(m.instance, value)
}

// 获取颜色。
//
// Get color.
func (m *TMemo) Color() TColor {
    return Memo_GetColor(m.instance)
}

// 设置颜色。
//
// Set color.
func (m *TMemo) SetColor(value TColor) {
    Memo_SetColor(m.instance, value)
}

// 获取约束控件大小。
func (m *TMemo) Constraints() *TSizeConstraints {
    return AsSizeConstraints(Memo_GetConstraints(m.instance))
}

// 设置约束控件大小。
func (m *TMemo) SetConstraints(value *TSizeConstraints) {
    Memo_SetConstraints(m.instance, CheckPtr(value))
}

// 获取设置控件双缓冲。
//
// Get Set control double buffering.
func (m *TMemo) DoubleBuffered() bool {
    return Memo_GetDoubleBuffered(m.instance)
}

// 设置设置控件双缓冲。
//
// Set Set control double buffering.
func (m *TMemo) SetDoubleBuffered(value bool) {
    Memo_SetDoubleBuffered(m.instance, value)
}

// 获取设置控件拖拽时的光标。
//
// Get Set the cursor when the control is dragged.
func (m *TMemo) DragCursor() TCursor {
    return Memo_GetDragCursor(m.instance)
}

// 设置设置控件拖拽时的光标。
//
// Set Set the cursor when the control is dragged.
func (m *TMemo) SetDragCursor(value TCursor) {
    Memo_SetDragCursor(m.instance, value)
}

// 获取拖拽方式。
//
// Get Drag and drop.
func (m *TMemo) DragKind() TDragKind {
    return Memo_GetDragKind(m.instance)
}

// 设置拖拽方式。
//
// Set Drag and drop.
func (m *TMemo) SetDragKind(value TDragKind) {
    Memo_SetDragKind(m.instance, value)
}

// 获取拖拽模式。
//
// Get Drag mode.
func (m *TMemo) DragMode() TDragMode {
    return Memo_GetDragMode(m.instance)
}

// 设置拖拽模式。
//
// Set Drag mode.
func (m *TMemo) SetDragMode(value TDragMode) {
    Memo_SetDragMode(m.instance, value)
}

// 获取控件启用。
//
// Get the control enabled.
func (m *TMemo) Enabled() bool {
    return Memo_GetEnabled(m.instance)
}

// 设置控件启用。
//
// Set the control enabled.
func (m *TMemo) SetEnabled(value bool) {
    Memo_SetEnabled(m.instance, value)
}

// 获取字体。
//
// Get Font.
func (m *TMemo) Font() *TFont {
    return AsFont(Memo_GetFont(m.instance))
}

// 设置字体。
//
// Set Font.
func (m *TMemo) SetFont(value *TFont) {
    Memo_SetFont(m.instance, CheckPtr(value))
}

// 获取隐藏选择。
func (m *TMemo) HideSelection() bool {
    return Memo_GetHideSelection(m.instance)
}

// 设置隐藏选择。
func (m *TMemo) SetHideSelection(value bool) {
    Memo_SetHideSelection(m.instance, value)
}

func (m *TMemo) Lines() *TStrings {
    return AsStrings(Memo_GetLines(m.instance))
}

func (m *TMemo) SetLines(value IStrings) {
    Memo_SetLines(m.instance, CheckPtr(value))
}

// 获取最大长度。
func (m *TMemo) MaxLength() int32 {
    return Memo_GetMaxLength(m.instance)
}

// 设置最大长度。
func (m *TMemo) SetMaxLength(value int32) {
    Memo_SetMaxLength(m.instance, value)
}

// 获取使用父容器颜色。
//
// Get parent color.
func (m *TMemo) ParentColor() bool {
    return Memo_GetParentColor(m.instance)
}

// 设置使用父容器颜色。
//
// Set parent color.
func (m *TMemo) SetParentColor(value bool) {
    Memo_SetParentColor(m.instance, value)
}

// 获取使用父容器双缓冲。
//
// Get Parent container double buffering.
func (m *TMemo) ParentDoubleBuffered() bool {
    return Memo_GetParentDoubleBuffered(m.instance)
}

// 设置使用父容器双缓冲。
//
// Set Parent container double buffering.
func (m *TMemo) SetParentDoubleBuffered(value bool) {
    Memo_SetParentDoubleBuffered(m.instance, value)
}

// 获取使用父容器字体。
//
// Get Parent container font.
func (m *TMemo) ParentFont() bool {
    return Memo_GetParentFont(m.instance)
}

// 设置使用父容器字体。
//
// Set Parent container font.
func (m *TMemo) SetParentFont(value bool) {
    Memo_SetParentFont(m.instance, value)
}

// 获取以父容器的ShowHint属性为准。
func (m *TMemo) ParentShowHint() bool {
    return Memo_GetParentShowHint(m.instance)
}

// 设置以父容器的ShowHint属性为准。
func (m *TMemo) SetParentShowHint(value bool) {
    Memo_SetParentShowHint(m.instance, value)
}

// 获取右键菜单。
//
// Get Right click menu.
func (m *TMemo) PopupMenu() *TPopupMenu {
    return AsPopupMenu(Memo_GetPopupMenu(m.instance))
}

// 设置右键菜单。
//
// Set Right click menu.
func (m *TMemo) SetPopupMenu(value IComponent) {
    Memo_SetPopupMenu(m.instance, CheckPtr(value))
}

// 获取只读。
func (m *TMemo) ReadOnly() bool {
    return Memo_GetReadOnly(m.instance)
}

// 设置只读。
func (m *TMemo) SetReadOnly(value bool) {
    Memo_SetReadOnly(m.instance, value)
}

func (m *TMemo) ScrollBars() TScrollStyle {
    return Memo_GetScrollBars(m.instance)
}

func (m *TMemo) SetScrollBars(value TScrollStyle) {
    Memo_SetScrollBars(m.instance, value)
}

// 获取显示鼠标悬停提示。
//
// Get Show mouseover tips.
func (m *TMemo) ShowHint() bool {
    return Memo_GetShowHint(m.instance)
}

// 设置显示鼠标悬停提示。
//
// Set Show mouseover tips.
func (m *TMemo) SetShowHint(value bool) {
    Memo_SetShowHint(m.instance, value)
}

// 获取Tab切换顺序序号。
//
// Get Tab switching sequence number.
func (m *TMemo) TabOrder() TTabOrder {
    return Memo_GetTabOrder(m.instance)
}

// 设置Tab切换顺序序号。
//
// Set Tab switching sequence number.
func (m *TMemo) SetTabOrder(value TTabOrder) {
    Memo_SetTabOrder(m.instance, value)
}

// 获取Tab可停留。
//
// Get Tab can stay.
func (m *TMemo) TabStop() bool {
    return Memo_GetTabStop(m.instance)
}

// 设置Tab可停留。
//
// Set Tab can stay.
func (m *TMemo) SetTabStop(value bool) {
    Memo_SetTabStop(m.instance, value)
}

// 获取控件可视。
//
// Get the control visible.
func (m *TMemo) Visible() bool {
    return Memo_GetVisible(m.instance)
}

// 设置控件可视。
//
// Set the control visible.
func (m *TMemo) SetVisible(value bool) {
    Memo_SetVisible(m.instance, value)
}

func (m *TMemo) WantReturns() bool {
    return Memo_GetWantReturns(m.instance)
}

func (m *TMemo) SetWantReturns(value bool) {
    Memo_SetWantReturns(m.instance, value)
}

func (m *TMemo) WantTabs() bool {
    return Memo_GetWantTabs(m.instance)
}

func (m *TMemo) SetWantTabs(value bool) {
    Memo_SetWantTabs(m.instance, value)
}

// 获取自动换行。
//
// Get Automatic line break.
func (m *TMemo) WordWrap() bool {
    return Memo_GetWordWrap(m.instance)
}

// 设置自动换行。
//
// Set Automatic line break.
func (m *TMemo) SetWordWrap(value bool) {
    Memo_SetWordWrap(m.instance, value)
}

// 设置改变事件。
//
// Set changed event.
func (m *TMemo) SetOnChange(fn TNotifyEvent) {
    Memo_SetOnChange(m.instance, fn)
}

// 设置控件单击事件。
//
// Set control click event.
func (m *TMemo) SetOnClick(fn TNotifyEvent) {
    Memo_SetOnClick(m.instance, fn)
}

// 设置上下文弹出事件，一般是右键时弹出。
//
// Set Context popup event, usually pop up when right click.
func (m *TMemo) SetOnContextPopup(fn TContextPopupEvent) {
    Memo_SetOnContextPopup(m.instance, fn)
}

// 设置双击事件。
func (m *TMemo) SetOnDblClick(fn TNotifyEvent) {
    Memo_SetOnDblClick(m.instance, fn)
}

// 设置拖拽下落事件。
//
// Set Drag and drop event.
func (m *TMemo) SetOnDragDrop(fn TDragDropEvent) {
    Memo_SetOnDragDrop(m.instance, fn)
}

// 设置拖拽完成事件。
//
// Set Drag and drop completion event.
func (m *TMemo) SetOnDragOver(fn TDragOverEvent) {
    Memo_SetOnDragOver(m.instance, fn)
}

// 设置拖拽结束。
//
// Set End of drag.
func (m *TMemo) SetOnEndDrag(fn TEndDragEvent) {
    Memo_SetOnEndDrag(m.instance, fn)
}

// 设置焦点进入。
//
// Set Focus entry.
func (m *TMemo) SetOnEnter(fn TNotifyEvent) {
    Memo_SetOnEnter(m.instance, fn)
}

// 设置焦点退出。
//
// Set Focus exit.
func (m *TMemo) SetOnExit(fn TNotifyEvent) {
    Memo_SetOnExit(m.instance, fn)
}

// 设置键盘按键按下事件。
//
// Set Keyboard button press event.
func (m *TMemo) SetOnKeyDown(fn TKeyEvent) {
    Memo_SetOnKeyDown(m.instance, fn)
}

// 设置键键下事件。
func (m *TMemo) SetOnKeyPress(fn TKeyPressEvent) {
    Memo_SetOnKeyPress(m.instance, fn)
}

// 设置键盘按键抬起事件。
//
// Set Keyboard button lift event.
func (m *TMemo) SetOnKeyUp(fn TKeyEvent) {
    Memo_SetOnKeyUp(m.instance, fn)
}

// 设置鼠标按下事件。
//
// Set Mouse down event.
func (m *TMemo) SetOnMouseDown(fn TMouseEvent) {
    Memo_SetOnMouseDown(m.instance, fn)
}

// 设置鼠标进入事件。
//
// Set Mouse entry event.
func (m *TMemo) SetOnMouseEnter(fn TNotifyEvent) {
    Memo_SetOnMouseEnter(m.instance, fn)
}

// 设置鼠标离开事件。
//
// Set Mouse leave event.
func (m *TMemo) SetOnMouseLeave(fn TNotifyEvent) {
    Memo_SetOnMouseLeave(m.instance, fn)
}

// 设置鼠标移动事件。
func (m *TMemo) SetOnMouseMove(fn TMouseMoveEvent) {
    Memo_SetOnMouseMove(m.instance, fn)
}

// 设置鼠标抬起事件。
//
// Set Mouse lift event.
func (m *TMemo) SetOnMouseUp(fn TMouseEvent) {
    Memo_SetOnMouseUp(m.instance, fn)
}

func (m *TMemo) CaretPos() TPoint {
    return Memo_GetCaretPos(m.instance)
}

func (m *TMemo) SetCaretPos(value TPoint) {
    Memo_SetCaretPos(m.instance, value)
}

// 获取能否撤销。
func (m *TMemo) CanUndo() bool {
    return Memo_GetCanUndo(m.instance)
}

// 获取修改。
//
// Get modified.
func (m *TMemo) Modified() bool {
    return Memo_GetModified(m.instance)
}

// 设置修改。
//
// Set modified.
func (m *TMemo) SetModified(value bool) {
    Memo_SetModified(m.instance, value)
}

// 获取选择的长度。
func (m *TMemo) SelLength() int32 {
    return Memo_GetSelLength(m.instance)
}

// 设置选择的长度。
func (m *TMemo) SetSelLength(value int32) {
    Memo_SetSelLength(m.instance, value)
}

// 获取选择的启始位置。
func (m *TMemo) SelStart() int32 {
    return Memo_GetSelStart(m.instance)
}

// 设置选择的启始位置。
func (m *TMemo) SetSelStart(value int32) {
    Memo_SetSelStart(m.instance, value)
}

// 获取选择的文本。
func (m *TMemo) SelText() string {
    return Memo_GetSelText(m.instance)
}

// 设置选择的文本。
func (m *TMemo) SetSelText(value string) {
    Memo_SetSelText(m.instance, value)
}

// 获取文本。
func (m *TMemo) Text() string {
    strLen := m.GetTextLen()
    if strLen != 0 {
        var buffStr string
        m.GetTextBuf(&buffStr, strLen + 1)
        return buffStr
    }
    return ""
}

// 设置文本。
func (m *TMemo) SetText(value string) {
    Memo_SetText(m.instance, value)
}

// 获取提示文本。
func (m *TMemo) TextHint() string {
    return Memo_GetTextHint(m.instance)
}

// 设置提示文本。
func (m *TMemo) SetTextHint(value string) {
    Memo_SetTextHint(m.instance, value)
}

// 获取依靠客户端总数。
func (m *TMemo) DockClientCount() int32 {
    return Memo_GetDockClientCount(m.instance)
}

// 获取停靠站点。
//
// Get Docking site.
func (m *TMemo) DockSite() bool {
    return Memo_GetDockSite(m.instance)
}

// 设置停靠站点。
//
// Set Docking site.
func (m *TMemo) SetDockSite(value bool) {
    Memo_SetDockSite(m.instance, value)
}

// 获取鼠标是否在客户端，仅VCL有效。
//
// Get Whether the mouse is on the client, only VCL is valid.
func (m *TMemo) MouseInClient() bool {
    return Memo_GetMouseInClient(m.instance)
}

// 获取当前停靠的可视总数。
//
// Get The total number of visible calls currently docked.
func (m *TMemo) VisibleDockClientCount() int32 {
    return Memo_GetVisibleDockClientCount(m.instance)
}

// 获取画刷对象。
//
// Get Brush.
func (m *TMemo) Brush() *TBrush {
    return AsBrush(Memo_GetBrush(m.instance))
}

// 获取子控件数。
//
// Get Number of child controls.
func (m *TMemo) ControlCount() int32 {
    return Memo_GetControlCount(m.instance)
}

// 获取控件句柄。
//
// Get Control handle.
func (m *TMemo) Handle() HWND {
    return Memo_GetHandle(m.instance)
}

// 获取父容器句柄。
//
// Get Parent container handle.
func (m *TMemo) ParentWindow() HWND {
    return Memo_GetParentWindow(m.instance)
}

// 设置父容器句柄。
//
// Set Parent container handle.
func (m *TMemo) SetParentWindow(value HWND) {
    Memo_SetParentWindow(m.instance, value)
}

func (m *TMemo) Showing() bool {
    return Memo_GetShowing(m.instance)
}

// 获取使用停靠管理。
func (m *TMemo) UseDockManager() bool {
    return Memo_GetUseDockManager(m.instance)
}

// 设置使用停靠管理。
func (m *TMemo) SetUseDockManager(value bool) {
    Memo_SetUseDockManager(m.instance, value)
}

func (m *TMemo) Action() *TAction {
    return AsAction(Memo_GetAction(m.instance))
}

func (m *TMemo) SetAction(value IComponent) {
    Memo_SetAction(m.instance, CheckPtr(value))
}

func (m *TMemo) BoundsRect() TRect {
    return Memo_GetBoundsRect(m.instance)
}

func (m *TMemo) SetBoundsRect(value TRect) {
    Memo_SetBoundsRect(m.instance, value)
}

// 获取客户区高度。
//
// Get client height.
func (m *TMemo) ClientHeight() int32 {
    return Memo_GetClientHeight(m.instance)
}

// 设置客户区高度。
//
// Set client height.
func (m *TMemo) SetClientHeight(value int32) {
    Memo_SetClientHeight(m.instance, value)
}

func (m *TMemo) ClientOrigin() TPoint {
    return Memo_GetClientOrigin(m.instance)
}

// 获取客户区矩形。
//
// Get client rectangle.
func (m *TMemo) ClientRect() TRect {
    return Memo_GetClientRect(m.instance)
}

// 获取客户区宽度。
//
// Get client width.
func (m *TMemo) ClientWidth() int32 {
    return Memo_GetClientWidth(m.instance)
}

// 设置客户区宽度。
//
// Set client width.
func (m *TMemo) SetClientWidth(value int32) {
    Memo_SetClientWidth(m.instance, value)
}

// 获取控件状态。
//
// Get control state.
func (m *TMemo) ControlState() TControlState {
    return Memo_GetControlState(m.instance)
}

// 设置控件状态。
//
// Set control state.
func (m *TMemo) SetControlState(value TControlState) {
    Memo_SetControlState(m.instance, value)
}

// 获取控件样式。
//
// Get control style.
func (m *TMemo) ControlStyle() TControlStyle {
    return Memo_GetControlStyle(m.instance)
}

// 设置控件样式。
//
// Set control style.
func (m *TMemo) SetControlStyle(value TControlStyle) {
    Memo_SetControlStyle(m.instance, value)
}

func (m *TMemo) Floating() bool {
    return Memo_GetFloating(m.instance)
}

// 获取控件父容器。
//
// Get control parent container.
func (m *TMemo) Parent() *TWinControl {
    return AsWinControl(Memo_GetParent(m.instance))
}

// 设置控件父容器。
//
// Set control parent container.
func (m *TMemo) SetParent(value IWinControl) {
    Memo_SetParent(m.instance, CheckPtr(value))
}

// 获取左边位置。
//
// Get Left position.
func (m *TMemo) Left() int32 {
    return Memo_GetLeft(m.instance)
}

// 设置左边位置。
//
// Set Left position.
func (m *TMemo) SetLeft(value int32) {
    Memo_SetLeft(m.instance, value)
}

// 获取顶边位置。
//
// Get Top position.
func (m *TMemo) Top() int32 {
    return Memo_GetTop(m.instance)
}

// 设置顶边位置。
//
// Set Top position.
func (m *TMemo) SetTop(value int32) {
    Memo_SetTop(m.instance, value)
}

// 获取宽度。
//
// Get width.
func (m *TMemo) Width() int32 {
    return Memo_GetWidth(m.instance)
}

// 设置宽度。
//
// Set width.
func (m *TMemo) SetWidth(value int32) {
    Memo_SetWidth(m.instance, value)
}

// 获取高度。
//
// Get height.
func (m *TMemo) Height() int32 {
    return Memo_GetHeight(m.instance)
}

// 设置高度。
//
// Set height.
func (m *TMemo) SetHeight(value int32) {
    Memo_SetHeight(m.instance, value)
}

// 获取控件光标。
//
// Get control cursor.
func (m *TMemo) Cursor() TCursor {
    return Memo_GetCursor(m.instance)
}

// 设置控件光标。
//
// Set control cursor.
func (m *TMemo) SetCursor(value TCursor) {
    Memo_SetCursor(m.instance, value)
}

// 获取组件鼠标悬停提示。
//
// Get component mouse hints.
func (m *TMemo) Hint() string {
    return Memo_GetHint(m.instance)
}

// 设置组件鼠标悬停提示。
//
// Set component mouse hints.
func (m *TMemo) SetHint(value string) {
    Memo_SetHint(m.instance, value)
}

// 获取组件总数。
//
// Get the total number of components.
func (m *TMemo) ComponentCount() int32 {
    return Memo_GetComponentCount(m.instance)
}

// 获取组件索引。
//
// Get component index.
func (m *TMemo) ComponentIndex() int32 {
    return Memo_GetComponentIndex(m.instance)
}

// 设置组件索引。
//
// Set component index.
func (m *TMemo) SetComponentIndex(value int32) {
    Memo_SetComponentIndex(m.instance, value)
}

// 获取组件所有者。
//
// Get component owner.
func (m *TMemo) Owner() *TComponent {
    return AsComponent(Memo_GetOwner(m.instance))
}

// 获取组件名称。
//
// Get the component name.
func (m *TMemo) Name() string {
    return Memo_GetName(m.instance)
}

// 设置组件名称。
//
// Set the component name.
func (m *TMemo) SetName(value string) {
    Memo_SetName(m.instance, value)
}

// 获取对象标记。
//
// Get the control tag.
func (m *TMemo) Tag() int {
    return Memo_GetTag(m.instance)
}

// 设置对象标记。
//
// Set the control tag.
func (m *TMemo) SetTag(value int) {
    Memo_SetTag(m.instance, value)
}

// 获取左边锚点。
func (m *TMemo) AnchorSideLeft() *TAnchorSide {
    return AsAnchorSide(Memo_GetAnchorSideLeft(m.instance))
}

// 设置左边锚点。
func (m *TMemo) SetAnchorSideLeft(value *TAnchorSide) {
    Memo_SetAnchorSideLeft(m.instance, CheckPtr(value))
}

// 获取顶边锚点。
func (m *TMemo) AnchorSideTop() *TAnchorSide {
    return AsAnchorSide(Memo_GetAnchorSideTop(m.instance))
}

// 设置顶边锚点。
func (m *TMemo) SetAnchorSideTop(value *TAnchorSide) {
    Memo_SetAnchorSideTop(m.instance, CheckPtr(value))
}

// 获取右边锚点。
func (m *TMemo) AnchorSideRight() *TAnchorSide {
    return AsAnchorSide(Memo_GetAnchorSideRight(m.instance))
}

// 设置右边锚点。
func (m *TMemo) SetAnchorSideRight(value *TAnchorSide) {
    Memo_SetAnchorSideRight(m.instance, CheckPtr(value))
}

// 获取底边锚点。
func (m *TMemo) AnchorSideBottom() *TAnchorSide {
    return AsAnchorSide(Memo_GetAnchorSideBottom(m.instance))
}

// 设置底边锚点。
func (m *TMemo) SetAnchorSideBottom(value *TAnchorSide) {
    Memo_SetAnchorSideBottom(m.instance, CheckPtr(value))
}

func (m *TMemo) ChildSizing() *TControlChildSizing {
    return AsControlChildSizing(Memo_GetChildSizing(m.instance))
}

func (m *TMemo) SetChildSizing(value *TControlChildSizing) {
    Memo_SetChildSizing(m.instance, CheckPtr(value))
}

// 获取边框间距。
func (m *TMemo) BorderSpacing() *TControlBorderSpacing {
    return AsControlBorderSpacing(Memo_GetBorderSpacing(m.instance))
}

// 设置边框间距。
func (m *TMemo) SetBorderSpacing(value *TControlBorderSpacing) {
    Memo_SetBorderSpacing(m.instance, CheckPtr(value))
}

// 获取指定索引停靠客户端。
func (m *TMemo) DockClients(Index int32) *TControl {
    return AsControl(Memo_GetDockClients(m.instance, Index))
}

// 获取指定索引子控件。
func (m *TMemo) Controls(Index int32) *TControl {
    return AsControl(Memo_GetControls(m.instance, Index))
}

// 获取指定索引组件。
//
// Get the specified index component.
func (m *TMemo) Components(AIndex int32) *TComponent {
    return AsComponent(Memo_GetComponents(m.instance, AIndex))
}

// 获取锚侧面。
func (m *TMemo) AnchorSide(AKind TAnchorKind) *TAnchorSide {
    return AsAnchorSide(Memo_GetAnchorSide(m.instance, AKind))
}

