
//----------------------------------------
// The code is automatically generated by the GenlibLcl tool.
// Copyright © ying32. All Rights Reserved.
// 
// Licensed under Apache License 2.0
//
//----------------------------------------


package vcl


import (
    . "github.com/ying32/govcl/vcl/api"
    . "github.com/ying32/govcl/vcl/types"
    "unsafe"
)

type TSizeConstraints struct {
    IObject
    instance uintptr
    // 特殊情况下使用，主要应对Go的GC问题，与LCL没有太多关系。
    ptr unsafe.Pointer
}

// 动态转换一个已存在的对象实例。
// 
// Dynamically convert an existing object instance.
func AsSizeConstraints(obj interface{}) *TSizeConstraints {
    instance, ptr := getInstance(obj)
    if instance == 0 { return nil }
    return &TSizeConstraints{instance: instance, ptr: ptr}
}

// -------------------------- Deprecated begin --------------------------
// 新建一个对象来自已经存在的对象实例指针。
// 
// Create a new object from an existing object instance pointer.
// Deprecated: use AsSizeConstraints.
func SizeConstraintsFromInst(inst uintptr) *TSizeConstraints {
    return AsSizeConstraints(inst)
}

// 新建一个对象来自已经存在的对象实例。
// 
// Create a new object from an existing object instance.
// Deprecated: use AsSizeConstraints.
func SizeConstraintsFromObj(obj IObject) *TSizeConstraints {
    return AsSizeConstraints(obj)
}

// 新建一个对象来自不安全的地址。注意：使用此函数可能造成一些不明情况，慎用。
// 
// Create a new object from an unsecured address. Note: Using this function may cause some unclear situations and be used with caution..
// Deprecated: use AsSizeConstraints.
func SizeConstraintsFromUnsafePointer(ptr unsafe.Pointer) *TSizeConstraints {
    return AsSizeConstraints(ptr)
}

// -------------------------- Deprecated end --------------------------
// 返回对象实例指针。
// 
// Return object instance pointer.
func (s *TSizeConstraints) Instance() uintptr {
    return s.instance
}

// 获取一个不安全的地址。
// 
// Get an unsafe address.
func (s *TSizeConstraints) UnsafeAddr() unsafe.Pointer {
    return s.ptr
}

// 检测地址是否为空。
// 
// Check if the address is empty.
func (s *TSizeConstraints) IsValid() bool {
    return s.instance != 0
}

// 检测当前对象是否继承自目标对象。
// 
// Checks whether the current object is inherited from the target object.
func (s *TSizeConstraints) Is() TIs {
    return TIs(s.instance)
}

// 动态转换当前对象为目标对象。
// 
// Dynamically convert the current object to the target object.
//func (s *TSizeConstraints) As() TAs {
//    return TAs(s.instance)
//}

// 获取类信息指针。
// 
// Get class information pointer.
func TSizeConstraintsClass() TClass {
    return SizeConstraints_StaticClassType()
}

// 复制一个对象，如果对象实现了此方法的话。
//
// Copy an object, if the object implements this method.
func (s *TSizeConstraints) Assign(Source IObject) {
    SizeConstraints_Assign(s.instance, CheckPtr(Source))
}

// 获取类名路径。
//
// Get the class name path.
func (s *TSizeConstraints) GetNamePath() string {
    return SizeConstraints_GetNamePath(s.instance)
}

// 获取类的类型信息。
//
// Get class type information.
func (s *TSizeConstraints) ClassType() TClass {
    return SizeConstraints_ClassType(s.instance)
}

// 获取当前对象类名称。
//
// Get the current object class name.
func (s *TSizeConstraints) ClassName() string {
    return SizeConstraints_ClassName(s.instance)
}

// 获取当前对象实例大小。
//
// Get the current object instance size.
func (s *TSizeConstraints) InstanceSize() int32 {
    return SizeConstraints_InstanceSize(s.instance)
}

// 判断当前类是否继承自指定类。
//
// Determine whether the current class inherits from the specified class.
func (s *TSizeConstraints) InheritsFrom(AClass TClass) bool {
    return SizeConstraints_InheritsFrom(s.instance, AClass)
}

// 与一个对象进行比较。
//
// Compare with an object.
func (s *TSizeConstraints) Equals(Obj IObject) bool {
    return SizeConstraints_Equals(s.instance, CheckPtr(Obj))
}

// 获取类的哈希值。
//
// Get the hash value of the class.
func (s *TSizeConstraints) GetHashCode() int32 {
    return SizeConstraints_GetHashCode(s.instance)
}

// 文本类信息。
//
// Text information.
func (s *TSizeConstraints) ToString() string {
    return SizeConstraints_ToString(s.instance)
}

// 设置改变事件。
//
// Set changed event.
func (s *TSizeConstraints) SetOnChange(fn TNotifyEvent) {
    SizeConstraints_SetOnChange(s.instance, fn)
}

func (s *TSizeConstraints) MaxHeight() TConstraintSize {
    return SizeConstraints_GetMaxHeight(s.instance)
}

func (s *TSizeConstraints) SetMaxHeight(value TConstraintSize) {
    SizeConstraints_SetMaxHeight(s.instance, value)
}

func (s *TSizeConstraints) MaxWidth() TConstraintSize {
    return SizeConstraints_GetMaxWidth(s.instance)
}

func (s *TSizeConstraints) SetMaxWidth(value TConstraintSize) {
    SizeConstraints_SetMaxWidth(s.instance, value)
}

func (s *TSizeConstraints) MinHeight() TConstraintSize {
    return SizeConstraints_GetMinHeight(s.instance)
}

func (s *TSizeConstraints) SetMinHeight(value TConstraintSize) {
    SizeConstraints_SetMinHeight(s.instance, value)
}

func (s *TSizeConstraints) MinWidth() TConstraintSize {
    return SizeConstraints_GetMinWidth(s.instance)
}

func (s *TSizeConstraints) SetMinWidth(value TConstraintSize) {
    SizeConstraints_SetMinWidth(s.instance, value)
}

